- Home
- Download

- GitHub

- News
- Documentation

- FAQ
- Tutorial
- API reference
- Examples

- XML Digital Signature
- XML Encryption
- XML Canonicalization
- Reporting Bugs
- Mailing list
- Related
- Authors

## keysstore

keysstore — Keys store implementation for Microsoft Cryptography API: Next Generation (CNG).

## Stability Level

Stable, unless otherwise indicated

## Functions

xmlSecKeyStoreId | xmlSecMSCngKeysStoreGetKlass ()
int | xmlSecMSCngKeysStoreAdoptKey ()
int | xmlSecMSCngKeysStoreLoad ()
int | xmlSecMSCngKeysStoreSave ()

## Types and Values

#define | xmlSecMSCngKeysStoreId

## Description

## Functions

### xmlSecMSCngKeysStoreGetKlass ()

    xmlSecKeyStoreId
    xmlSecMSCngKeysStoreGetKlass (void);

The MSCng list based keys store klass.

#### Returns

MSCng list based keys store klass.

### xmlSecMSCngKeysStoreAdoptKey ()

    int
    xmlSecMSCngKeysStoreAdoptKey (xmlSecKeyStorePtr store,
                                  xmlSecKeyPtr key);

Adds `key` to the `store` .

#### Parameters

store | the pointer to MSCng keys store. |
key | the pointer to key. |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecMSCngKeysStoreLoad ()

    int
    xmlSecMSCngKeysStoreLoad (xmlSecKeyStorePtr store,
                              const char *uri,
                              xmlSecKeysMngrPtr keysMngr);

Reads keys from an XML file.

#### Parameters

store | the pointer to MSCng keys store. |
uri | the filename. |
keysMngr | the pointer to associated keys manager. |

#### Returns

0 on success or a negative value if an error occurs.

### xmlSecMSCngKeysStoreSave ()

    int
    xmlSecMSCngKeysStoreSave (xmlSecKeyStorePtr store,
                              const char *filename,
                              xmlSecKeyDataType type);

Writes keys from `store` to an XML file.

#### Parameters

store | the pointer to MSCng keys store. |
filename | the filename. |
type | the saved keys type (public, private, ...). |

#### Returns

0 on success or a negative value if an error occurs.

## Types and Values

### xmlSecMSCngKeysStoreId

    #define xmlSecMSCngKeysStoreId xmlSecMSCngKeysStoreGetKlass()

A MSCng keys store klass id.